﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;
using System.Collections;
using System.Diagnostics;

namespace MultiSelectListBindingProblem
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
			DataContext = _dataContext;
		}

		TestDataContext _dataContext = new TestDataContext();

		private void TestSelectAll_Click(object sender, RoutedEventArgs e)
		{
            List<TestItem> test = new List<TestItem>();
            foreach (var item in _dataContext.Items)
            {                
                test.Add(item);
            }
            _dataContext.SelectedVMItems = test as IEnumerable;
		}
                
	}

	public class TestItem : NPCHelper
	{
		TestDataContext _c;
		string _text;
		public TestItem(TestDataContext c, string text) { _c = c; _text = text; }

		public override string ToString() { return _text; }

		public string Text { get { return _text; } }
	}

	public class TestDataContext : NPCHelper
	{
		public TestDataContext()
		{
			for (int i = 0; i < 100; i++)
				_items.Add(new TestItem(this, i.ToString()));
		}
        IEnumerable _selectedVMitems ;
        public IEnumerable SelectedVMItems 
        {
            get { return _selectedVMitems; }
            set 
            {
                _selectedVMitems = value;
                foreach (var item in SelectedVMItems)
                {
                    Debug.WriteLine((item as TestItem).Text);
                    Debug.WriteLine("****");
                }                
                FirePropertyChanged("SelectedVMItems");
            }
        }


		ObservableCollection<TestItem> _items = new ObservableCollection<TestItem>();
		public ObservableCollection<TestItem> Items { get { return _items; } }
	}

	public class NPCHelper : INotifyPropertyChanged
	{
		public event PropertyChangedEventHandler PropertyChanged;
		public void FirePropertyChanged(string prop)
		{
			if (PropertyChanged != null)
				PropertyChanged(this, new PropertyChangedEventArgs(prop));
		}
	}
}
